//
//  QNKDebug.h
//  QuantumKit
//
//  Created by Logan Collins on 7/10/13.
//  Copyright (c) 2013 Sunflower Softworks. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <QuantumKit/QuantumKitDefines.h>


QUANTUMKIT_EXTERN BOOL QNKDebugLoggingIsEnabled();
QUANTUMKIT_EXTERN void QNKDebugLoggingSetEnabled(BOOL enabled);


#if defined(DEBUG) && DEBUG

#define QNKDebugLog(...) NSLog(@"DEBUG: %@", [NSString stringWithFormat:__VA_ARGS__]);
#define QNKMethodDebugLog(...) NSLog(@"DEBUG: %@:%@, %@", [self class], NSStringFromSelector(_cmd), [NSString stringWithFormat:__VA_ARGS__]);

#else

#define QNKDebugLog(...) \
if (QNKDebugLoggingIsEnabled()) { \
NSLog(@"DEBUG: %@", [NSString stringWithFormat:__VA_ARGS__]); \
}

#define QNKMethodDebugLog(...) \
if (QNKDebugLoggingIsEnabled()) { \
NSLog(@"DEBUG: %@:%@, %@", [self class], NSStringFromSelector(_cmd), [NSString stringWithFormat:__VA_ARGS__]); \
}

#endif
